/*
SUPPORT: sinass Sharma, Ashish
*/
/******************************************************************************
 * Job:             Load_STG2DM_Dow_sales_fact              A5W0V4GZ.BF0004QF *
 * Description:                                                               *
 *                                                                            *
 * Metadata Server: puneasd10.apac.sas.com                                    *
 * Port:            8561                                                      *
 * Location:        /Users/Ashish/My Folder/Jobs                              *
 *                                                                            *
 * Server:          MIMain                                  A5W0V4GZ.AR000003 *
 *                                                                            *
 * Source Tables:   STG_DOW_SALES - DIDM_STG.STG_DOW_SALES  A5W0V4GZ.BB000BV5 *
 *                  GEOGRAPHY_DM - DI_DM.GEOGRAPHY_DM       A5W0V4GZ.BB00062I *
 *                  PROD_HIER_SK - DI_MON.PROD_HIER_SK      A5W0V4GZ.BB000672 *
 * Target Tables:   STG_DOW_SALES_X - DI_MON.STG_DOW_SALES_X        A5W0V4GZ.BB00079I *
 *                  ETLS_DOW_SALES  -                    A5W0V4GZ.BB0008YS *
 *                   TLS_DOW_EVENT_SALES                                 *
 * Generated on:    Thursday, 17 March, 2011 3:21:04 PM IST                   *
 * Generated by:    sinass@ROW                                                *
 * Version:         SAS Data Integration Studio 4.21                          *
 ******************************************************************************/

/* General macro variables  */
%let jobID = %quote(A5W0V4GZ.BF0004QF);
%let etls_jobName = %nrquote(Load_STG2DM_Dow_sales_fact);
%let etls_userID = %nrquote(sinass@ROW);


/* Setup to capture return codes  */
%global job_rc trans_rc sqlrc;
%let sysrc = 0;
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr;

%macro rcSet(error);
   %if (&error gt &trans_rc) %then
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then
      %let job_rc = &error;
%mend rcSet;

%macro rcSetDS(error);
   if &error gt input(symget('trans_rc'),12.) then
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS;

%let IOMServer = %nrquote(MIMain);

/* Setup for capturing job status  */
%let etls_startTime = %sysfunc(datetime(),datetime.);
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

%global etls_debug;
%macro etls_setDebug;
   %if %str(&etls_debug) ne 0 %then
      OPTIONS MPRINT%str(;);
%mend;
%etls_setDebug;

/*---- Start of Pre-Process Code  ----*/

/**/
%etl_initjobparam (monlib=di_mon, jobname=%nrquote(&etls_jobName));
/**/
%etl_initchangeflags;

/*---- End of Pre-Process Code  ----*/

%rcSet(&syserr);
%rcSet(&sqlrc);
/*============================================================================*
 * Step:            Uw_create_date_format                   A5W0V4GZ.BH000NGK *
 * Transform:       User Written                                              *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    STG_DOW_SALES - DIDM_STG.STG_DOW_SALES  A5W0V4GZ.BB000BV5 *
 * Target Table:    User Written -                          A5W0V4GZ.BK000JIK *
 *                   work.DIDM_STG.STG_DOW_SALES                              *
 *                                                                            *
 * User Written:    SourceCode                                                *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000NGK);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

/*---- Start of User Written Code  ----*/
%macro etl_check_exist;

   %local GEO_PROD_LOW_DATA_LVL l_gp_low_data_lvl
   l_max_date_lvl abort;

   %global etlp_exception_table err_table;
   %let abort = 0 ;

   /* Check for existence of DI_DM.DATE_DM dataset */
   %if NOT %sysfunc(exist(DI_DM.DATE_DM)) %then %do;
      %let etl_msg = %etl_msg(mid=5005,args=DI_DM.DATE_DM);
      %put &etl_msg;
      %let abort = 1 ;
   %end;
   %else %do;
      %let date_dm_obs = %di_util_nobs(DI_DM.DATE_DM);
      %if &date_dm_obs = 0 %then %do;
         %let etl_msg = %etl_msg(mid=5008,args=DI_DM.DATE_DM);
         %put &etl_msg;
      %end;
   %end;

   /* Check for existence of DI_DM.PRODUCT_DM dataset */
   %if NOT %sysfunc(exist(DI_DM.PRODUCT_DM)) %then %do;
      %let etl_msg = %etl_msg(mid=5005,args=DI_DM.PRODUCT_DM);
      %put &etl_msg;
      %let abort = 2 ;
   %end;
   %else %do;
      %let product_dm_obs = %di_util_nobs(DI_DM.PRODUCT_DM);
      %if &product_dm_obs = 0 %then %do;
         %let etl_msg = %etl_msg(mid=5008,args=DI_DM.PRODUCT_DM);
         %put &etl_msg;
      %end;
   %end;

   /* Check for existence of DI_DM.GEOGRAPHY_DM dataset */
   %if NOT %sysfunc(exist(DI_DM.GEOGRAPHY_DM)) %then %do;
      %let etl_msg = %etl_msg(mid=5005,args=DI_DM.GEOGRAPHY_DM);
      %put &etl_msg;
      %let abort = 3 ;
   %end;
   %else %do;
      %let geography_dm_obs = %di_util_nobs(DI_DM.GEOGRAPHY_DM);
      %if &geography_dm_obs = 0 %then %do;
         %let etl_msg = %etl_msg(mid=5008,args=DI_DM.GEOGRAPHY_DM);
         %put &etl_msg;
      %end;
   %end;

   /* Check for existence of DI_DM.GEOGRAPHY_HIER_ASSOC_DM dataset */
   %if NOT %sysfunc(exist(DI_DM.GEOGRAPHY_HIER_ASSOC_DM)) %then %do;
      %let etl_msg = %etl_msg(mid=5005,args=DI_DM.GEOGRAPHY_HIER_ASSOC_DM);
      %put &etl_msg;
      %let abort = 4 ;
   %end;
   %else %do;
      %let geo_hier_obs = %di_util_nobs(DI_DM.GEOGRAPHY_HIER_ASSOC_DM);
      %if &geography_dm_obs = 0 %then %do;
         %let etl_msg = %etl_msg(mid=5008,args=DI_DM.GEOGRAPHY_HIER_ASSOC_DM);
         %put &etl_msg;
      %end;
   %end;

   /* Check for existence of DI_DM.PRODUCT_HIER_ASSOC_DM dataset */
   %if NOT %sysfunc(exist(DI_DM.PRODUCT_HIER_ASSOC_DM)) %then %do;
      %let etl_msg = %etl_msg(mid=5005,args=DI_DM.PRODUCT_HIER_ASSOC_DM);
      %put &etl_msg;
      %let abort = 5 ;
   %end;
   %else %do;
      %let prod_hier_obs = %di_util_nobs(DI_DM.PRODUCT_HIER_ASSOC_DM);
      %if &prod_hier_obs = 0 %then %do;
         %let etl_msg = %etl_msg(mid=5008,args=DI_DM.PRODUCT_HIER_ASSOC_DM);
         %put &etl_msg;
      %end;
   %end;

   %if %symexist(part_sk)=0 %then
   %do;
      %global low_geo_lvl low_prod_lvl;

      proc sql noprint;
         select spec_value into :GEO_PROD_LOW_DATA_LVL
         from di_dm.global_setting
         where upcase(spec_nm)='GEO_PROD_LOW_DATA_LVL';
      quit;

      %if &GEO_PROD_LOW_DATA_LVL eq %str() %then %do;
         %let etl_msg = %etl_msg(mid=5012,args=GEO_PROD_LOW_DATA_LVL GLOBAL_SETTING);
         %put &etl_msg;
         %let abort = 6 ;
      %end;
      %else %do;/* check for validity of global_setting */
         proc sql noprint;
            select data_lvl_id into :l_gp_low_data_lvl
            from di_dm.data_lvl
            where data_lvl_id = &GEO_PROD_LOW_DATA_LVL;
         quit;
         %if &l_gp_low_data_lvl ne &GEO_PROD_LOW_DATA_LVL %then %do;
            %let etl_msg = %etl_msg(mid=5012,args=GLOBAL_SETTING.GEO_PROD_LOW_DATA_LVL DI_DM.DATA_LVL);
            %put &etl_msg;
            %let abort = 7 ;
         %end;
      %end;

         proc sql noprint;
            select geo_lvl, prod_lvl into :low_geo_lvl,:low_prod_lvl
            from di_dm.data_lvl
            where data_lvl_id = &GEO_PROD_LOW_DATA_LVL;
         quit;

      %di_etl_rcset(error=&sqlrc,code=job_rc);

      %put  geo_lvl=&low_geo_lvl;
      %put  prod_lvl=&low_prod_lvl;
   %end;

   %if &abort gt 0 %then %do;
      %etl_abort;
   %end;

   proc sql noprint;
      select max(DATE_LVL) into :l_max_date_lvl from DI_DM.DATE_DM;
   quit;

   data WEEK_SK(keep=START END LABEL FMTNAME TYPE HLO);
      set DI_DM.DATE_DM(rename=(FISCAL_START_DT=START
                                FISCAL_END_DT=END
                                DATE_SK=LABEL)) end=last;
      retain FMTNAME 'week_sk' type 'N';
      attrib HLO length=$1;
      where DATE_LVL=&l_max_date_lvl;
   run;

   proc sql noprint;
      insert into WEEK_SK (START,END,FMTNAME,TYPE,HLO,LABEL)
      values (.,.,'week_sk','N','O',-1);
   quit;

   proc format cntlin=WEEK_SK;
   run;

   /*Check if library trg_lib exists. If not, then assign di_dm to trg_lib*/
   %if %sysfunc(libref(trg_lib)) ne 0 %then %do;
      libname trg_lib (di_dm);
      /* delete indexes and constraints */
      %etl_drop(trg_lib.DOW_SALES_FACT,ic);
      %etl_drop(trg_lib.DOW_SALES_FACT,index);
      %etl_drop(trg_lib.DOW_EVENT_SALES_FACT,ic);
      %etl_drop(trg_lib.DOW_EVENT_SALES_FACT,index);
   %end;

   /*Check if library stg_lib exists. If not, then assign didm_stg to stg_lib*/
   %if %sysfunc(libref(stg_lib)) ne 0 %then %do;
      libname stg_lib (didm_stg);
      %if NOT %symexist(src_table) %then
         %global src_table;
      %if "&src_table" eq "" %then
         %let src_table=STG_DOW_SALES;
   %end;

   %put src_table=&src_table;

   /*Check if library err_lib exists. If not, then assign di_mon to err_lib*/

   %if (%sysfunc(libref(err_lib)) eq 0) AND (%symexist(part_sk)) %then %do;
      %let err_table=STG_DOW_SALES_X_&part_sk;
   %end;
   %else %do;
      libname err_lib (di_mon);
      %let err_table=STG_DOW_SALES_X;
   %end;

   %put err_table=&err_table;


   /* Get record count from DOW_SALES_FACT */
   /*   %let etls_recordsBefore_nonevent=%di_util_nobs(trg_lib.DOW_SALES_FACT);*/
   /* Get record count from DOW_EVENT_SALES_FACT */
   /*   %let etls_recordsBefore_event=%di_util_nobs(trg_lib.DOW_EVENT_SALES_FACT);*/

   /*Create Job_status in err_lib if not exist*/
   %if not %sysfunc( exist(err_lib.job_status)) %then %do;
      %di_util_lock(di_mon.job_status);
      data err_lib.job_status;
         set di_mon.job_status;
         stop;
      run;
      %di_util_unlock(di_mon.job_status);
   %end;

   /*Create error table in err_lib if not exist*/
   %if not %sysfunc( exist(err_lib.&err_table)) %then %do;
      %di_util_lock(di_mon.STG_DOW_SALES_X);
      data err_lib.&err_table;
         set di_mon.STG_DOW_SALES_X;
         stop;
      run;
      %di_util_unlock(di_mon.STG_DOW_SALES_X);
   %end;

   /*Set exception table and exception records for job_status macro*/
   %let etlp_exception_table=ERR_LIB.&err_table;
   %put etlp_exception_table=&etlp_exception_table;

   data _null_;
       call symput('etl_xobsbefore', %di_util_nobs(&etlp_exception_table));
   run;


   /*---- End of User Written Code  ----*/

   %rcSet(&syserr);
   %rcSet(&sqlrc);

%mend etl_check_exist;

%etl_check_exist;

/**  Step end Uw_create_date_format **/

/*============================================================================*
 * Step:            Lookup                                  A5W0V4GZ.BH000NGL *
 * Transform:       Lookup                                                    *
 * Description:                                                               *
 *                                                                            *
 * Source Tables:   User Written -                          A5W0V4GZ.BK000JIK *
 *                   work.DIDM_STG.STG_DOW_SALES                              *
 *                  GEOGRAPHY_DM - DI_DM.GEOGRAPHY_DM       A5W0V4GZ.BB00062I *
 *                  PROD_HIER_SK - DI_MON.PROD_HIER_SK      A5W0V4GZ.BB000672 *
 * Target Table:    lkp_dow_sales - work.W5Z1Z8XO           A5W0V4GZ.BK000JIL *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000NGL);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let runTime = %sysfunc(datetime());


/*---- Begin DATA step to perform lookups  ----*/
DATA  WORK.LKP_DOW_SALES
         (keep = PROD_HIER_SK GEO_HIER_SK DATE_SK DAY_OF_WEEK
                 SALES_UNITS SALES_AMT CHANGE_FLG SALES_DT )
      WORK.DOW_SALES_ERROR
         (keep = PROD_ID GEO_ID SALES_DT SALES_UNITS SALES_AMT
                 CHANGE_FLG ETLS_EXCEPTION_COND ETL_ERROR_JOBRUNTIME);

   attrib PROD_ID length=$32
          GEO_ID length=$32
          PROD_HIER_SK length=6
          GEO_HIER_SK length=4
          DATE_SK length=4
          DAY_OF_WEEK length=4
          SALES_DT length=8 format=DATE9.
          SALES_UNITS length=8 format=NLNUM12.2
          SALES_AMT length=8 format=NLNUM20.3
          CHANGE_FLG length=$1
          ETLS_EXCEPTION_COND  length=$200
          ETL_ERROR_JOBRUNTIME length=8 format=datetime16.
;

   retain missing0-missing1 0;

   etls_assign_target_value = 0;
   /* Assign variables used for error/exception handling  */
   etls_source_row      = _n_;
   etls_write_to_error_table  = 0;

   /* Build hash objects from lookup tables before reading first source row  */
   if (_n_ = 1) then
   do;
      /* Build hash h0 from lookup table DI_DM.GEOGRAPHY_DM */
      nlobs = .;
      dsid = open("DI_DM.GEOGRAPHY_DM");
      if (dsid > 0) then
      do;
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then
            nlobs = attrn(dsid, 'NLOBS');
         else
            nlobs = -1;

         dsid = close(dsid);
         if (nlobs ^= 0) then
         do;
            if (nlobs > 0) then
               exponent = ceil(log2(nlobs));
            else
               exponent = 8;
            declare hash h0(dataset: "DI_DM.GEOGRAPHY_DM", hashexp: exponent);
            h0.defineKey( "GEO_ID");
            h0.defineData( "GEO_HIER_SK");
            h0.defineDone();
            if (nlobs = -1) then
            do;
               if (h0.Num_Items < 1) then
               do;
                  put "NOTE: Lookup table is empty: DI_DM.GEOGRAPHY_DM";
                  missing0 = 98;
               end;
            end;
         end;
         else
         do;
            put "NOTE: Lookup table is empty: DI_DM.GEOGRAPHY_DM";
            missing0 = 98;
         end;
      end;
      else
      do;
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " DI_DM.GEOGRAPHY_DM";

         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " DI_DM.GEOGRAPHY_DM";

         abort 3;
      end;

      /* Build hash h1 from lookup table DI_MON.PROD_HIER_SK */
      nlobs = .;
      dsid = open("DI_MON.PROD_HIER_SK");
      if (dsid > 0) then
      do;
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then
            nlobs = attrn(dsid, 'NLOBS');
         else
            nlobs = -1;

         dsid = close(dsid);
         if (nlobs ^= 0) then
         do;
            if (nlobs > 0) then
               exponent = ceil(log2(nlobs));
            else
               exponent = 8;
            declare hash h1(dataset: "DI_MON.PROD_HIER_SK", hashexp: exponent);
            h1.defineKey( "PROD_ID");
            h1.defineData( "PROD_HIER_SK");
            h1.defineDone();
            if (nlobs = -1) then
            do;
               if (h1.Num_Items < 1) then
               do;
                  put "NOTE: Lookup table is empty: DI_MON.PROD_HIER_SK";
                  missing1 = 98;
               end;
            end;
         end;
         else
         do;
            put "NOTE: Lookup table is empty: DI_MON.PROD_HIER_SK";
            missing1 = 98;
         end;
      end;
      else
      do;
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " DI_MON.PROD_HIER_SK";

         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " DI_MON.PROD_HIER_SK";

         abort 3;
      end;

      call missing (GEO_ID, GEO_HIER_SK, PROD_ID, PROD_HIER_SK);

   end; /* All hash objects have been defined */

   /* Read a row from the source table  */
   set stg_lib.&src_table. end = eof;

   /* Is the current key value stored in hash h0?  */
   if (missing0 < 1) then
   do;
      rc0 = h0.find();
   end;
   else
      rc0 = missing0;

   /* Is the current key value stored in hash h1?  */
   if (missing1 < 1) then
   do;
      rc1 = h1.find();
   end;
   else
      rc1 = missing1;

   DATE_SK=input(put(SALES_DT,week_sk.),best12.);

   if DATE_SK ne -1 then
   do;
      DAY_OF_WEEK=weekday(SALES_DT);
   end;

   /* Examine success of lookups  */
   if ( rc0=0 and rc1=0 and DATE_SK ne -1 and SALES_UNITS gt 0 and SALES_AMT ge 0) then
   do;
      /* Write row to target  */
      output WORK.LKP_DOW_SALES;
      return;
   end;
   else
   do;
       /*---- Custom Validation: Invalid PROD_ID  ----*/
      if (MISSING(PROD_HIER_SK)) then
      do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x," * %etl_msg(mid=5305,args=PROD_ID)"),$200.);
      end;  /* if (MISSING(PROD_HIER_SK)) */

      /*---- Custom Validation: Invalid GEO_ID  ----*/
      if (MISSING(GEO_HIER_SK)) then
      do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x," * %etl_msg(mid=5305,args=GEO_ID) "),$200.);
      end;  /* if (MISSING(GEO_HIER_SK)) */

      /*---- Custom Validation: Invalid SALES_DT  ----*/
      if DATE_SK eq -1 then
      do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x," * %etl_msg(mid=5305,args=SALES_DT) "),$200.);
      end;  /* if (MISSING(DATE_SK)) */

      /*---- Custom Validation: Invalid SALES_UNITS  ----*/
     if SALES_UNITS le 0 then
     do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x," * %etl_msg(mid=5331,args=SALES_UNITS 0) "),$200.);
      end;

      /*---- Custom Validation: Invalid SALES_AMT  ----*/
     if SALES_AMT lt 0 then
     do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x," * %etl_msg(mid=5328,args=SALES_AMT 0) "),$200.);
      end;

         ETL_ERROR_JOBRUNTIME = &runTime;
      /* Write row to error table?  */
         output WORK.DOW_SALES_ERROR;
   end; /* One or more lookups failed */
run;

%di_etl_rcset(error=&syserr,code=job_rc);


proc append base=err_lib.&err_table. data=WORK.DOW_SALES_ERROR force;
run;

%di_etl_rcset(error=&syserr,code=job_rc);

/*============================================================================*
 * Step:            Remove_duplicates                              A5W0V4GZ.BH000KUT *
 * Transform:       Sort                                                      *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    Lookup Target - work.temp_sales_sks     A5W0V4GZ.BK000HC2 *
 * Target Table:    sort_sales - work.sort_sales            A5W0V4GZ.BK000HC3 *
 *============================================================================*/

/*---- Start of Pre-Process Code  ----*/

%di_etl_keep_work_table(lkp_dow_sales);
/*---- End of Pre-Process Code  ----*/

%di_etl_rcset(error=&syserr,code=job_rc);

%macro remove_duplicate;
proc sort data = LKP_DOW_SALES
   out =SORTED_DOW_SALES
      NODUPKEY
      EQUALS
      dupout =DUP_DOW_SALES_FACT() ;
   by
     PROD_HIER_SK
     GEO_HIER_SK
     DATE_SK
     DAY_OF_WEEK
   ;
run;

%di_etl_rcset(error=&syserr,code=job_rc);

%local duplicate_record_count;
%let duplicate_record_count=%di_util_nobs(DUP_DOW_SALES_FACT);

%if &duplicate_record_count gt 0 %then
%do;

DATA  DUP_DOW_SALES_FACT1
         (keep = PROD_ID GEO_ID SALES_DT SALES_UNITS SALES_AMT CHANGE_FLG
                 ETLS_EXCEPTION_COND ETL_ERROR_JOBRUNTIME);
   attrib PROD_ID length=$32
          GEO_ID length=$32
          PROD_HIER_SK length=6
          GEO_HIER_SK length=4
          SALES_DT length=8 format=DATE9.
          SALES_UNITS length=8 format=NLNUM12.2
          SALES_AMT length=8 format=NLNUM20.3
          CHANGE_FLG length=$1
        ETLS_EXCEPTION_COND  length=$200
          ETL_ERROR_JOBRUNTIME length=8 format=datetime16.
;

   retain missing0-missing1 0;

   etls_assign_target_value = 0;
   /* Assign variables used for error/exception handling  */
   etls_source_row      = _n_;
   etls_write_to_error_table  = 0;

   /* Build hash objects from lookup tables before reading first source row  */
   if (_n_ = 1) then
   do;
      /* Build hash h0 from lookup table DI_DM.GEOGRAPHY_DM */
      nlobs = .;
      dsid = open("DI_DM.GEOGRAPHY_DM");
      if (dsid > 0) then
      do;
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then
            nlobs = attrn(dsid, 'NLOBS');
         else
            nlobs = -1;

         dsid = close(dsid);
         if (nlobs ^= 0) then
         do;
            if (nlobs > 0) then
               exponent = ceil(log2(nlobs));
            else
               exponent = 8;
            declare hash h0(dataset: "DI_DM.GEOGRAPHY_DM", hashexp: exponent);
            h0.defineKey( "GEO_HIER_SK");
            h0.defineData( "GEO_ID");
            h0.defineDone();
            if (nlobs = -1) then
            do;
               if (h0.Num_Items < 1) then
               do;
                  put "NOTE: Lookup table is empty: DI_DM.GEOGRAPHY_DM";
                  missing0 = 98;
               end;
            end;
         end;
         else
         do;
            put "NOTE: Lookup table is empty: DI_DM.GEOGRAPHY_DM";
            missing0 = 98;
         end;
      end;
      else
      do;
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " DI_DM.GEOGRAPHY_DM";

         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " DI_DM.GEOGRAPHY_DM";

         abort 3;
      end;

      /* Build hash h1 from lookup table DI_MON.PROD_HIER_SK */
      nlobs = .;
      dsid = open("DI_MON.PROD_HIER_SK");
      if (dsid > 0) then
      do;
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then
            nlobs = attrn(dsid, 'NLOBS');
         else
            nlobs = -1;

         dsid = close(dsid);
         if (nlobs ^= 0) then
         do;
            if (nlobs > 0) then
               exponent = ceil(log2(nlobs));
            else
               exponent = 8;
            declare hash h1(dataset: "DI_MON.PROD_HIER_SK", hashexp: exponent);
            h1.defineKey( "PROD_HIER_SK");
            h1.defineData( "PROD_ID");
            h1.defineDone();
            if (nlobs = -1) then
            do;
               if (h1.Num_Items < 1) then
               do;
                  put "NOTE: Lookup table is empty: DI_MON.PROD_HIER_SK";
                  missing1 = 98;
               end;
            end;
         end;
         else
         do;
            put "NOTE: Lookup table is empty: DI_MON.PROD_HIER_SK";
            missing1 = 98;
         end;
      end;
      else
      do;
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " DI_MON.PROD_HIER_SK";

         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " DI_MON.PROD_HIER_SK";

         abort 3;
      end;

      call missing (GEO_ID, GEO_HIER_SK, PROD_ID, PROD_HIER_SK);

   end; /* All hash objects have been defined */

   /* Read a row from the source table  */
   set DUP_DOW_SALES_FACT end = eof;

   /* Is the current key value stored in hash h0?  */
   if (missing0 < 1) then
   do;
      rc0 = h0.find();
   end;
   else
      rc0 = missing0;

   /* Is the current key value stored in hash h1?  */
   if (missing1 < 1) then
   do;
      rc1 = h1.find();
   end;
   else
      rc1 = missing1;

   /* Examine success of lookups  */
   if ( rc0=0 and rc1=0) then
   do;
      /* Write row to target  */
      ETLS_EXCEPTION_COND = put("%etl_msg(mid=5351)",$200.);
      ETL_ERROR_JOBRUNTIME = &runTime;
      output DUP_DOW_SALES_FACT1;
   end;
run;

%di_etl_rcset(error=&syserr,code=job_rc);


proc append base=err_lib.&err_table. data=DUP_DOW_SALES_FACT1 force;
run;

%di_etl_rcset(error=&syserr,code=job_rc);
%end;
%mend remove_duplicate;

%remove_duplicate

/*============================================================================*
 * Step:            UW_identify_event                         A5W0V4GZ.BH000BW8 *
 * Transform:       Table Loader (Version 2.1)                                *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    Sorted_dow_sales                        A5W0V4GZ.BK0009N9 *
 * Target Table:    ETLS_DOW_SALES -                    A5W0V4GZ.BB0003DU *
 *                   ETLS_DOW_EVENT_SALES                                 *
 *                                                                            *
 * User Written:    UW Loader                                                 *
 *============================================================================*/

/*---- Start of Pre-Process Code  ----*/

%di_etl_keep_work_table(SORTED_DOW_SALES);
/*---- End of Pre-Process Code  ----*/

%macro create_lkp_dataset;

%if %symexist(part_sk)=0 %then
%do;

   %let etls_lib=DI_DM;

 %local min_sales_dt max_sales_dt;

proc sql noprint;
   select (min(SALES_DT) - 7) , (max(SALES_DT) + 7) into
   :min_sales_dt,:max_sales_dt
   from SORTED_DOW_SALES;
quit;

data _null_;
set DI_DM.GEO_DATE;
if &max_sales_dt ge start_dt and &max_sales_dt lt end_dt then
do;
   call symputx('max_sales_dt',end_dt);
end;
run;

data _null_;
set DI_DM.GEO_DATE;
if &min_sales_dt gt start_dt and &min_sales_dt le end_dt then
do;
   call symputx('min_sales_dt',start_dt);
end;
run;

%put min_sales_dt=&min_sales_dt;

   data GEO_DATE;
   set DI_DM.GEO_DATE;
      where START_DT ge &min_sales_dt
      and END_DT le &max_sales_dt
      and GEO_DATE_TYPE=3;
   run;

   %di_etl_rcset(error=&syserr,code=job_rc);

   data DATE_LKP(keep=GEO_HIER_SK PROD_HIER_SK START_DT DATE_FLG DATE_SK)
        DATE_LKP_GP1(keep=GEO_HIER_SK PROD_HIER_SK START_DT DATE_FLG DATE_SK);
   set GEO_DATE;
      attrib EVENT_DT length=8 format=date9.;
      attrib DATE_FLG length=$1.;
      attrib DATE_SK length=4;
      retain DATE_FLG '1';
   if END_DT eq START_DT then
   do;

      DATE_SK=input(put(START_DT,week_sk.),best12.);
      if (GEO_HIER_SK=1 and PROD_HIER_SK=1)
      then output DATE_LKP_GP1;
      else output DATE_LKP;
   end;
   else
   do;
      PREV_DT_SK =.;
      do until (END_DT lt START_DT);
         DATE_SK=input(put(START_DT,week_sk.),best12.);
         if (DATE_SK ne PREV_DT_SK) then do;

            if (GEO_HIER_SK=1 and PROD_HIER_SK=1)
            then output DATE_LKP_GP1;
            else output DATE_LKP;

            PREV_DT_SK=DATE_SK;
         end;
         START_DT=START_DT+1;
      end;
   end;
   run;

   %di_etl_rcset(error=&syserr,code=job_rc);


   proc sql noprint;
   create table GEO_PROD_DATE_LKP as
      select   geo_hier.GEO_HIER_SK,
               geo_hier.PARENT_GEO_HIER_SK,
               prod_hier.PROD_HIER_SK,
               prod_hier.PARENT_PROD_HIER_SK,
               gd.DATE_SK,
               gd.DATE_FLG as GP_DATE_FLG
   from
      DATE_LKP gd,
      DI_DM.GEOGRAPHY_HIER_ASSOC_DM geo_hier,
      DI_DM.PRODUCT_HIER_ASSOC_DM prod_hier
   where
      gd.GEO_HIER_SK=geo_hier.PARENT_GEO_HIER_SK
      and geo_hier.GEO_HIER_ASSOC_CD=1
      and gd.PROD_HIER_SK=prod_hier.PARENT_PROD_HIER_SK
      and prod_hier.PROD_HIER_ASSOC_CD=1
      and geo_hier.GEO_LVL=&low_geo_lvl
      and prod_hier.PROD_LVL=&low_prod_lvl;
   quit;

   %di_etl_rcset(error=&sqlrc,code=job_rc);


%end;
%else %do;
   %let etls_lib=d_&part_sk;
   %put Partition_id = &part_sk;;
   proc copy in=err_lib out=work;
   select DATE_LKP_GP1 GEO_PROD_DATE_LKP;
   run;

   proc sql noprint;
   create table GEO_PROD_DATE_LKP1 as
   select lkp.* from
      work.GEO_PROD_DATE_LKP lkp,
      DI_DM.PRODUCT_HIER_ASSOC_DM prod_hier
   where
      lkp.PROD_HIER_SK=prod_hier.PROD_HIER_SK
     and prod_hier.PARENT_PROD_HIER_SK=&PART_SK.;
   quit;
%end;

%mend create_lkp_dataset;
%create_lkp_dataset;

data work.ETLS_DOW_SALES (keep=%di_util_column_names(trg_lib.DOW_SALES_FACT) CHANGE_FLG )
     work.ETLS_DOW_EVENT_SALES (keep=%di_util_column_names(trg_lib.DOW_EVENT_SALES_FACT) CHANGE_FLG) ;;
   attrib PROD_HIER_SK length=6 ;
   attrib GEO_HIER_SK length=4 ;
   attrib DATE_SK length=4 ;
   attrib DAY_OF_WEEK length=4 ;
   attrib SALES_UNITS length=8 FORMAT=NLNUM12.2 INFORMAT=NLNUM12.2 ;
   attrib SALES_AMT length=8  FORMAT=NLNUM20.3  INFORMAT=NLNUM20.3 ;
   attrib CHANGE_FLG length=$1;
   attrib SALES_DT length=8 FORMAT=DATE9.;
   attrib DATE_FLG length=$1;
   attrib GP_DATE_FLG length=$1;

   retain missing0-missing1 0;

   etls_assign_target_value = 0;
   /* Assign variables used for error/exception handling  */
   etls_source_row      = _n_;
   etls_write_to_error_table  = 0;

   /* Build hash objects from lookup tables before reading first source row  */
   if (_n_ = 1) then
   do;
      %di_util_hash_define( h_num = 0,
                            dsn   = %QUOTE(work.DATE_LKP_GP1),
                            d_key = %QUOTE("DATE_SK"),
                            d_data= %QUOTE("DATE_FLG")
                            );
      %di_util_hash_define( h_num = 1,
                            dsn   = %QUOTE(work.GEO_PROD_DATE_LKP1),
                            d_key = %QUOTE("DATE_SK","GEO_HIER_SK","PROD_HIER_SK"),
                            d_data= %QUOTE("GP_DATE_FLG")
                            );

      call missing (GEO_HIER_SK, PROD_HIER_SK, DATE_FLG, DATE_SK, GP_DATE_FLG);

   end; /* All hash objects have been defined */

   /* Read a row from the source table  */
   set SORTED_DOW_SALES end = eof;
   /* Is the current key value stored in hash h0?  */
   if ( missing0 < 1) then do;
      rc0 = h0.find();
   end;
   if DATE_FLG ='1' then do;
      output ETLS_DOW_EVENT_SALES;
   end;
   else do;
      if (missing1 < 1 ) then do ;
      rc1 = h1.find();
      end;
      if GP_DATE_FLG = '1'
            then
               output ETLS_DOW_EVENT_SALES;
           else
               output ETLS_DOW_SALES;

   end;
run;

%di_etl_rcset(error=&syserr,code=job_rc);

/*============================================================================*
 * Step:            UW Table Loader                         A5W0V4GZ.BH000BW8 *
 * Transform:       Table Loader (Version 2.1)                                *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    ETLS_DOW_SALES, ETLS_DOW_EVENT_SALES    A5W0V4GZ.BK0009N9 *
 * Target Table:    DI_DM.DOW_SALES_FACT -                    A5W0V4GZ.BB0003DU *
 *                   DI_DM.DOW_EVENT_SALES_FACT                                 *
 *                                                                            *
 * User Written:    UW Loader                                                 *
 *============================================================================*/

/*---- Start of Pre-Process Code  ----*/

%di_etl_keep_work_table(ETLS_DOW_SALES ETLS_DOW_EVENT_SALES);
/*---- End of Pre-Process Code  ----*/

%di_etl_rcset(error=&syserr,code=job_rc);

   /* Get record count from DI_DM.DOW_SALES_FACT */
   %let etls_recordsBefore=%di_util_nobs(trg_lib.DOW_SALES_FACT);

data trg_lib.DOW_SALES_FACT (keep=%di_util_column_names(trg_lib.DOW_SALES_FACT));
merge trg_lib.DOW_SALES_FACT ETLS_DOW_SALES;
by PROD_HIER_SK GEO_HIER_SK DATE_SK DAY_OF_WEEK;
if upcase(CHANGE_FLG) = "&etl_delete_flg" then delete;
run;

%di_etl_rcset(error=&syserr,code=job_rc);

   %di_util_index_name(
       lib             = trg_lib,
       table           = DOW_SALES_FACT,
       columns         = prod_hier_sk,
       create_idx_name = prod_hier_sk
    );

%di_etl_rcset(error=&syscc,code=job_rc);


/* Get record count from DI_DM.DOW_SALES_FACT */
%let etls_recordsAfter=%di_util_nobs(trg_lib.DOW_SALES_FACT);
/*record job status for each table        */
%let etls_endTime=%sysfunc(putn(%sysfunc(datetime()), datetime21.));

%let etls_table = %nrquote(DOW_SALES_FACT);

%etls_sendJobstatus(source_table = stg_lib.&src_table,dataset=err_lib.job_status);

/* Get record count from DI_DM.DOW_EVENT_SALES_FACT */
%let etls_recordsBefore=%di_util_nobs(trg_lib.DOW_EVENT_SALES_FACT);

data trg_lib.DOW_EVENT_SALES_FACT (keep=%di_util_column_names(trg_lib.DOW_EVENT_SALES_FACT));
merge trg_lib.DOW_EVENT_SALES_FACT ETLS_DOW_EVENT_SALES;
by PROD_HIER_SK GEO_HIER_SK DATE_SK DAY_OF_WEEK;
if upcase(CHANGE_FLG) = "&etl_delete_flg" then delete;
run;

%di_etl_rcset(error=&syserr,code=job_rc);

   %di_util_index_name(
       lib             = trg_lib,
       table           = DOW_EVENT_SALES_FACT,
       columns         = prod_hier_sk,
       create_idx_name = prod_hier_sk
    );

%di_etl_rcset(error=&syscc,code=job_rc);


/* Get record count from DI_DM.DOW_EVENT_SALES_FACT */
%let etls_recordsAfter=%di_util_nobs(trg_lib.DOW_EVENT_SALES_FACT);

%let etls_table = %nrquote(DOW_EVENT_SALES_FACT);

%etls_sendJobstatus(source_table = stg_lib.&src_table,dataset=err_lib.job_status);

libname err_lib clear;
libname stg_lib clear;
libname trg_lib clear;

