/* 
SUPPORT: sinass Sharma, Ashish
*/ 
/****************************************************************************** 
 * Job:             Load_STG2DM_Price_fact_future           A5W0V4GZ.BF0002IA * 
 * Description:                                                               * 
 *                                                                            * 
 * Metadata Server: puneasd10.apac.sas.com                                    * 
 * Port:            8561                                                      * 
 * Location:        /Users/Rhuta/My Folder/Job_Cycle7                         * 
 *                                                                            * 
 * Server:          MIMain                                  A5W0V4GZ.AR000003 * 
 *                                                                            * 
 * Source Tables:   PROD_HIER_SK - DI_MON.PROD_HIER_SK      A5W0V4GZ.BB000ALQ * 
 *                  GEOGRAPHY_DM - DI_DM.GEOGRAPHY_DM       A5W0V4GZ.BB000AH1 * 
 *                  PRICE_FACT_FUTURE -                     A5W0V4GZ.BB000AJL * 
 *                   DI_DM.PRICE_FACT_FUTURE                                  * 
 *                  STG_PROD_PRICE_FUTURE -                 A5W0V4GZ.BB000API * 
 *                   DIDM_STG.STG_PROD_PRICE_FUTURE                           * 
 * Target Table:    PRICE_FACT_FUTURE -                     A5W0V4GZ.BB000AJL * 
 *                   DI_DM.PRICE_FACT_FUTURE                                  * 
 *                                                                            * 
 * Generated on:    Monday, March 15, 2010 1:59:00 PM IST                     * 
 * Generated by:    sinruk@row                                                * 
 * Version:         SAS Data Integration Studio 4.2                           * 
 ******************************************************************************/ 

/* General macro variables  */ 
%let jobID = %quote(A5W0V4GZ.BF0002IA);
%let etls_jobName = %nrquote(Load_STG2DM_Price_fact_future);
%let etls_userID = %nrquote(sinruk@row);

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let sysrc = 0;
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

/* Create metadata macro variables */
%let IOMServer      = %nrquote(MIMain);

/* Setup for capturing job status  */ 
%let etls_startTime = %sysfunc(datetime(),datetime.);
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*---- Start of Pre-Process Code  ----*/ 

%etl_initjobparam (monlib=di_mon, jobname=%nrquote(&etls_jobName));
/**/
%etl_initchangeflags;
/*---- End of Pre-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*---- Start of User Written Code  ----*/ 

/*============================================================================* 
 * Step:            UW-Pre Process                                            * 
 * Transform:       User Written                                              * 
 *============================================================================*/ 
%macro etl_check_exist;

   %local l_current_date_sk etl_msg abort date_dm_obs;
   %let abort = 0 ;

   /* Abort if current_date_sk is null */
   proc sql noprint;
      select spec_value
      into :l_current_date_sk
      from di_dm.global_setting
      where spec_nm="CURRENT_DATE_SK";
   quit;

   %let l_current_date_sk = &l_current_date_sk;
   %if (&l_current_date_sk eq %str(0) or &l_current_date_sk eq %str() or &l_current_date_sk eq %str(.)) %then %do;  
      %let etl_msg = %etl_msg(mid=5012,args=CURRENT_DATE_SK GLOBAL_SETTING);
      %put &etl_msg;
      %let abort = 1 ;
   %end;

   /* Check for existence of DI_DM.DATE_DM dataset */
   %if NOT %sysfunc(exist(DI_DM.DATE_DM)) %then %do;
      %let etl_msg = %etl_msg(mid=5005,args=DI_DM.DATE_DM);
      %put &etl_msg;
      %let abort = 2 ;
   %end;
   %else %do;
      %let date_dm_obs = %di_util_nobs(DI_DM.DATE_DM);
      %if &date_dm_obs = 0 %then %do;
         %let etl_msg = %etl_msg(mid=5008,args=DI_DM.DATE_DM);
         %put &etl_msg;
      %end;
   %end;

   /* Check for existence of DI_DM.GEOGRAPHY_DM dataset */
   %if NOT %sysfunc(exist(DI_DM.GEOGRAPHY_DM)) %then %do;
      %let etl_msg = %etl_msg(mid=5005,args=DI_DM.GEOGRAPHY_DM);
      %put &etl_msg;
      %let abort = 3 ;
   %end;

   /* Check for existence of DI_MON.PROD_HIER_SK dataset */
   %if NOT %sysfunc(exist(DI_MON.PROD_HIER_SK)) %then %do;
      %let etl_msg =  %etl_msg(mid=5005,args=DI_MON.PROD_HIER_SK);
      %put &etl_msg;
      %let abort = 4 ;
   %end;

   %if &abort gt 0 %then %do;
      %etl_abort;
   %end;

   /*---- Read current_date_sk ---------*/
   %global wk_end_dt ;
   %let wk_end_dt =0;

   proc sql noprint;
      select (fiscal_start_dt - 1)
      into :wk_end_dt
      from di_dm.date_dm
      where date_sk = &l_current_date_sk;
   quit;

   %if etlp_price_types=%str() %then %let etlp_price_types=(1,3);;

   %rcSet(&syserr); 
   %rcSet(&sqlrc); 

   %global err_table;

   /*Check if library trg_lib exists. If not, then assign di_dm to trg_lib*/
   %if %sysfunc(libref(trg_lib)) ne 0 %then %do;
      libname trg_lib (di_dm);
   %end;

   /*Check if library stg_lib exists. If not, then assign didm_stg to stg_lib*/
   %if %sysfunc(libref(stg_lib)) ne 0 %then %do;
      libname stg_lib (didm_stg);
      %global src_table;   
      %let src_table=stg_prod_price_future;
   %end;

   %put src_table=&src_table;


   /*Check if library err_lib exists. If not, then assign di_mon to err_lib*/

   %if (%sysfunc(libref(err_lib)) eq 0) AND (%symexist(part_sk)) %then %do;
      %let err_table=STG_PROD_PRICE_FUTURE_X_&part_sk;
   %end;
   %else %do;
      libname err_lib (di_mon);
      %let err_table=STG_PROD_PRICE_FUTURE_X;
   %end;

   %put err_table=&err_table;

   /*Check existance of target table*/
   %if not %sysfunc( exist(trg_lib.PRICE_FACT_FUTURE)) %then %do;
      data trg_lib.PRICE_FACT_FUTURE;
         set di_dm.PRICE_FACT_FUTURE;
         stop;
      run;
   %end;

   %global etls_recordsBefore_pff etls_recordsAfter_pff;    
   %let etls_recordsBefore_pff=0;    
   %let etls_recordsAfter_pff=0;    

   /* Get record count from PRICE_FACT_FUTURE */
   %let etls_recordsBefore_pff=%di_util_nobs(trg_lib.PRICE_FACT_FUTURE);

   /*Create Job_status in err_lib if not exist*/
   %if not %sysfunc( exist(err_lib.job_status)) %then %do;
      %di_util_lock(di_mon.job_status);

      data err_lib.job_status;
         set di_mon.job_status;
         stop;
      run;
      %di_util_unlock(di_mon.job_status);
   %end;

   /*Create error table in err_lib if not exist*/
   %if not %sysfunc( exist(err_lib.&err_table)) %then %do;
      %di_util_lock(di_mon.STG_PROD_PRICE_FUTURE_X);
      data err_lib.&err_table;
         set di_mon.STG_PROD_PRICE_FUTURE_X;
         stop;
      run;
      %di_util_unlock(di_mon.STG_PROD_PRICE_FUTURE_X);
   %end;

   /*Set exception table and exception records for job_status macro*/
   %let etlp_exception_table=ERR_LIB.&err_table; 
   %put etlp_exception_table=&etlp_exception_table;

   data _null_; 
       call symput('etl_xobsbefore', %di_util_nobs(&etlp_exception_table));
   run;

%mend etl_check_exist;

%etl_check_exist;

/*---- End of User Written Code  ----*/ 

/*============================================================================* 
 * Step:            Lkp_surr_keys                           A5W0V4GZ.BH000H4Q * 
 * Transform:       Lookup                                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables:   User Written Code Target -              A5W0V4GZ.BK000E0D * 
 *                   DIDM_STG.STG_PROD_PRICE_FUTURE                           * 
 *                  PROD_HIER_SK - DI_MON.PROD_HIER_SK      A5W0V4GZ.BB000ALQ * 
 *                  GEOGRAPHY_DM - DI_DM.GEOGRAPHY_DM       A5W0V4GZ.BB000AH1 * 
 * Target Table:    Lkp_surr_keys - work.Lkp_surr_keys      A5W0V4GZ.BK000E0E * 
 *============================================================================*/ 

%let transformID = %quote(A5W0V4GZ.BH000H4Q);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.); 

%let runTime = %sysfunc(datetime()); 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete Lkp_surr_keys;
quit;


%macro stg_prod_price_future_lkp;

%if %di_util_nobs(stg_lib.&src_table) eq 0 %then %do;
      /* create empty dataset for next step to consume */
DATA  work.Lkp_surr_keys
         ( keep = PROD_HIER_SK GEO_HIER_SK GEO_ID PROD_ID EFFECTIVE_DT EXPIRATION_DT 
                 REGULAR_PRICE ACTUAL_PRICE PRICE_TYPE CHANGE_FLG )
      ; 
   
   attrib PROD_HIER_SK length=6
          GEO_HIER_SK length=4 label="Geography Hierarchy Key"
          GEO_ID length=$32
          PROD_ID length=$32
          EFFECTIVE_DT length=8 format=DATE9.
          EXPIRATION_DT length=8 format=DATE9.
          REGULAR_PRICE length=8
          ACTUAL_PRICE length=8
          PRICE_TYPE length=4
          CHANGE_FLG length=$1
          ; 
   stop;
 run; 
%end;
%else %do;
/*---- Begin DATA step to perform lookups  ----*/ 
DATA  work.Lkp_surr_keys
         ( keep = PROD_HIER_SK GEO_HIER_SK GEO_ID PROD_ID EFFECTIVE_DT EXPIRATION_DT 
                 REGULAR_PRICE ACTUAL_PRICE PRICE_TYPE CHANGE_FLG )
      ; 
   
   attrib PROD_HIER_SK length=6
          GEO_HIER_SK length=4 label="Geography Hierarchy Key"
          GEO_ID length=$32
          PROD_ID length=$32
          EFFECTIVE_DT length=8 format=DATE9.
          EXPIRATION_DT length=8 format=DATE9.
          REGULAR_PRICE length=8
          ACTUAL_PRICE length=8
          PRICE_TYPE length=4
          CHANGE_FLG length=$1
          ; 
   
   retain missing0-missing1 0; 
   
   etls_assign_target_value = 0; 
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table DI_MON.PROD_HIER_SK */ 
      nlobs = .; 
      dsid = open("DI_MON.PROD_HIER_SK"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "DI_MON.PROD_HIER_SK", hashexp: exponent);
            h0.defineKey( "PROD_ID");
            h0.defineData( "PROD_HIER_SK");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: DI_MON.PROD_HIER_SK";
                  missing0 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: DI_MON.PROD_HIER_SK";
            missing0 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " DI_MON.PROD_HIER_SK";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " DI_MON.PROD_HIER_SK";
         
         abort 3; 
      end; 
      
      /* Build hash h1 from lookup table DI_DM.GEOGRAPHY_DM */ 
      nlobs = .; 
      dsid = open("DI_DM.GEOGRAPHY_DM"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h1(dataset: "DI_DM.GEOGRAPHY_DM", hashexp: exponent);
            h1.defineKey( "GEO_ID");
            h1.defineData( "GEO_HIER_SK");
            h1.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h1.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: DI_DM.GEOGRAPHY_DM";
                  missing1 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: DI_DM.GEOGRAPHY_DM";
            missing1 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " DI_DM.GEOGRAPHY_DM";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " DI_DM.GEOGRAPHY_DM";
         
         abort 3; 
      end; 
      
      call missing (PROD_ID, PROD_HIER_SK, GEO_ID, GEO_HIER_SK); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set stg_lib.&src_table end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   if (missing0 < 1) then 
   do; 
      rc0 = h0.find();
   end; 
   else 
      rc0 = missing0; 
      
   /* Is the current key value stored in hash h1?  */ 
   if (missing1 < 1) then 
   do; 
      rc1 = h1.find();
   end; 
   else 
      rc1 = missing1; 
      
   /* Examine success of lookups  */ 
   if ( rc0=0 and rc1=0 ) then 
   do; 
      /* Write row to target  */ 
      output work.Lkp_surr_keys; 
      return; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc0 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
            /* Check: Lookup table has no rows-Set target columns to missing  */ 
            call missing (PROD_HIER_SK); 
            etls_assign_target_value = 1; 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Set target columns to missing  */ 
            call missing (PROD_HIER_SK); 
            etls_assign_target_value = 1; 
         end; 
      end; 
      
      if (rc1 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc1 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
            /* Check: Lookup table has no rows-Set target columns to missing  */ 
            call missing (GEO_HIER_SK); 
            etls_assign_target_value = 1; 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Set target columns to missing  */ 
            call missing (GEO_HIER_SK); 
            etls_assign_target_value = 1; 
         end; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (etls_assign_target_value eq 1) then 
         /* Write row to target  */ 
         output work.Lkp_surr_keys; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "Source records with errors: " error_total ; 
      put "Total lookup exceptions: " exception_total ; 
   end; 

run; 

%rcSet(&syserr); 
%end;

%mend stg_prod_price_future_lkp;

%stg_prod_price_future_lkp

/**  Step end Lkp_surr_keys **/

/*---- Start of User Written Code  ----*/ 

/*============================================================================* 
 * Step:            Val_price_fact_future                   A5W0V4GZ.BH00066U * 
 * Transform:       Data Validation                                           * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Ext_price_fact_future -                 A5W0V4GZ.BK000538 * 
 *                   work.Ext_price_fact_future                               * 
 * Target Table:    Val_price_fact_future -                 A5W0V4GZ.BK000539 * 
 *                   work.Val_price_fact_future                               * 
 *                                                                            * 
 * User Written:    SourceCode                                                * 
 *============================================================================*/ 


%di_etl_keep_work_table( Lkp_surr_keys);

%macro etls_Validate; 

   %let runTime = %sysfunc(datetime()); 
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete Val_price_fact_future;
   quit;
   
   /*---- Begin checks for Custom, Missing Values, and Invalid Values  ----*/ 
   data work.Val_price_fact_future
         (keep = PROD_HIER_SK GEO_HIER_SK GEO_ID PROD_ID EFFECTIVE_DT EXPIRATION_DT 
                 REGULAR_PRICE ACTUAL_PRICE PRICE_TYPE CHANGE_FLG UPDATED_DTTM)
        work.etls_Errors
         (keep = GEO_ID PROD_ID EFFECTIVE_DT EXPIRATION_DT REGULAR_PRICE ACTUAL_PRICE 
                 PRICE_TYPE CHANGE_FLG ETLS_EXCEPTION_COND ETL_ERROR_JOBRUNTIME);
   
      set Lkp_surr_keys;

      attrib ETLS_EXCEPTION_COND length=$300;
      attrib ETL_ERROR_JOBRUNTIME length=8 format=datetime16.; 
      attrib UPDATED_DTTM length=8 format=datetime16.; 
      ETL_Error_JobRunTime = &runTime;
      UPDATED_DTTM = &runTime;
      CHANGE_FLG=UPCASE(CHANGE_FLG);

      /*---- Custom Validation: Prod ID validation  ----*/ 
      if (missing(PROD_HIER_SK)) then 
      do; 
        ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=PROD_ID)"),$300.);      
      end;  /* if (missing(PROD_HIER_SK)) */

      /*---- Custom Validation: Geo ID Validation  ----*/ 
      if (missing(GEO_HIER_SK)) then 
      do; 
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=GEO_ID)"),$300.);           
      end;  /* if (missing(GEO_HIER_SK)) */

      /*---- Custom Validation: Price_type  ----*/ 
      if (PRICE_TYPE not in &etlp_price_types.) then 
      do; 
        ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=PRICE_TYPE)"),$300.);          
      end;  /* if (PRICE_TYPE not in (&etls_price_types.)) */
      
      /*---- Custom Validation: Reject current records  ----*/ 
      if (EFFECTIVE_DT <= &wk_end_dt) then 
      do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5330)"),$300.);           
      end;  /* if (EFFECTIVE_DT <= &wk_end_dt) */

      /*---- Custom Validation: If missing EXPIRATION_DT then set to  "31DEC5999"d ----*/ 
      if (missing(EXPIRATION_DT)) then 
      do; 
        EXPIRATION_DT ="31DEC5999"d;      
      end;  /* if (missing(EXPIRATION_DT)) */
      
      /*---- Custom Validation: Invalid Effective_dt  ----*/ 
      if (EFFECTIVE_DT ge EXPIRATION_DT) then 
      do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5331,args=Expiration_dt Effective_dt)"),$300.);            
      end;  /* if (EFFECTIVE_DT ge EXPIRATION_DT) */
      
      /*---- Custom Validation: Invalid Regular_price  ----*/ 
      if (REGULAR_PRICE < ACTUAL_PRICE) then 
      do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5328,args=Regular_price Actual_price)"),$300.);             
      end;  /* if (REGULAR_PRICE < ACTUAL_PRICE) */
      
      /*---- Custom Validation: Non negative regular price  ----*/ 
      if (REGULAR_PRICE <= 0) then 
      do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5331,args=REGULAR_PRICE 0)"),$300.);              
      end;  /* if (REGULAR_PRICE <= 0) */
      
      /*---- Custom Validation: Non negative actual price  ----*/ 
      if (ACTUAL_PRICE  <= 0) then 
      do; 
        ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5331,args=ACTUAL_PRICE 0)"),$300.);              
      end;  /* if (ACTUAL_PRICE  <= 0) */

      /* move record to error file  */ 
      if (ETLS_EXCEPTION_COND ne "") then 
         output work.etls_Errors;
      /* move record to output file  */ 
      else 
         output work.Val_price_fact_future;
   run;
          
   %rcSet(&syserr); 

   proc append base = err_lib.&err_table 
      data = work.etls_Errors force; 
   run;

   %rcSet(&syserr); 
   
%mend etls_Validate;

%etls_Validate;

%rcSet(&syserr); 
/*---- End of User Written Code  ----*/ 

/*---- Start of User Written Code  ----*/ 

/*============================================================================* 
 * Step:            Load_price_fact_future                  A5RCIHUB.BC0004KR * 
 * Transform:       Table Loader (Version 2.1)                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    Valid_future_prices -                   A5RCIHUB.BE0008DH * 
 *                   work.Valid_future_prices                                 * 
 * Target Table:    PRICE_FACT_FUTURE -                     A5RCIHUB.BR0002MN * 
 *                   DI_DM.PRICE_FACT_FUTURE                                  * 
 *                                                                            * 
 * User Written:    etl_loader_match_merge                                    * 
 *============================================================================*/ 

%di_etl_keep_work_table(Val_price_fact_future );

%let etls_reccheckexist = 0;
%let etls_recordsbefore =%di_util_nobs(TRG_LIB.PRICE_FACT_FUTURE);
%let etls_table = %nrquote(PRICE_FACT_FUTURE);
%let etls_lib   = %nrquote(DI_DM);

%macro etls_loader_ppf;

   proc sort data=Val_price_fact_future nodupkey noequals
             dupout = work.Val_price_fact_future_x;
      by prod_hier_sk geo_hier_sk  effective_dt;
   run;

   %rcSet(&syserr); 
   
   /* Insert duplicate records into Error  */ 
   
   data WORK.Val_price_fact_future_x(keep=GEO_ID PROD_ID EFFECTIVE_DT EXPIRATION_DT REGULAR_PRICE 
                     ACTUAL_PRICE PRICE_TYPE CHANGE_FLG ETLS_EXCEPTION_COND ETL_ERROR_JOBRUNTIME);
      set Val_price_fact_future_x;
      attrib ETLS_EXCEPTION_COND length=$300;
      attrib ETL_ERROR_JOBRUNTIME length=8 format=datetime16.;
      ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5351)"),$300.);   
      ETL_ERROR_JOBRUNTIME = datetime();
   run;   

   %rcSet(&syserr); 
   
   proc append base = err_lib.&err_table 
               data = WORK.Val_price_fact_future_x force;
   run;

   %rcSet(&syserr); 

   %if &Full_refresh eq 0 %then %do; 
      %if %di_util_nobs(Val_price_fact_future) eq 0 %then %do;
         
         data TRG_LIB.PRICE_FACT_FUTURE;
            set TRG_LIB.PRICE_FACT_FUTURE;
            where valid_from_dt gt &wk_end_dt;
         run;        
      %end;    
      %else %do;
      /* Merge with Price_fact_Future and track changes */
      
      data TRG_LIB.PRICE_FACT_FUTURE;
         merge TRG_LIB.PRICE_FACT_FUTURE (in = dm)
               Val_price_fact_future (in = stg rename=(effective_dt=valid_from_dt expiration_dt=valid_to_dt
                          actual_price=n_act_price regular_price=n_reg_price price_type=n_price_type
                          updated_dttm=n_upd_dttm));
         
         by prod_hier_sk geo_hier_sk  valid_from_dt; 
         
         if change_flg ne "&etl_delete_flg";
         if valid_from_dt gt &wk_end_dt.; 
         
         if stg then do;
         
            if (dm = 0) or 
               (actual_price ne n_act_price or
                regular_price ne n_reg_price or
                price_type ne n_price_type) then do;
                
               actual_price=n_act_price;
               regular_price=n_reg_price;
               price_type=n_price_type;
               updated_dttm= n_upd_dttm;
            end;           
            
         end;
      
         last_geo_hier_sk=lag(geo_hier_sk);
         last_act_price=lag(actual_price);
         last_reg_price=lag(regular_price);
         last_price_type=lag(price_type);

         if first.geo_hier_sk or last_geo_hier_sk ne geo_hier_sk or 
            last_act_price ne actual_price or
            last_reg_price ne regular_price or
            last_price_type ne price_type;

         drop last_geo_hier_sk last_act_price last_reg_price last_price_type prod_id geo_id change_flg
              n_act_price n_reg_price n_price_type n_upd_dttm;
     run;
     
     %rcSet(&syserr); 

      /* Close out records */
      data TRG_LIB.PRICE_FACT_FUTURE (drop = etls_closedate);

         set TRG_LIB.PRICE_FACT_FUTURE;
         by prod_hier_sk geo_hier_sk ; 

         /* close out any history records if they exist  */ 
         if not last.geo_hier_sk then do;      
            obsnum = _n_ + 1;
            set TRG_LIB.PRICE_FACT_FUTURE(keep = valid_from_dt
                        rename = (valid_from_dt = etls_closedate))
                point = obsnum;
            valid_to_dt = etls_closedate - 1;            
         end;       
      run;    
      
      %rcSet(&syserr); 
     
     %end;
   %end;   
   %else %do; /* Full Refresh option set */

      /* Remove CHANGE_FLG = D before appending */
      /* Compress data based on changes */
      
      data Val_price_fact_future_compres;

         set Val_price_fact_future(rename=(effective_dt=valid_from_dt expiration_dt=valid_to_dt)
                                   where=(change_flg ne "&etl_delete_flg"));
         by prod_hier_sk geo_hier_sk ;

         last_act_price=lag(actual_price);
         last_reg_price=lag(regular_price);
         last_price_type=lag(price_type);

         if first.geo_hier_sk or 
            last_act_price ne actual_price or
            last_reg_price ne regular_price or
            last_price_type ne price_type;

         drop last_act_price last_reg_price last_price_type prod_id geo_id change_flg;
      run;
      
      %rcSet(&syserr); 
      
      /* Close out records */
      data Val_price_fact_future_compres (drop = etls_closedate);

         set Val_price_fact_future_compres;
         by prod_hier_sk geo_hier_sk ; 

         /* close out any history records if they exist  */ 
         if not last.geo_hier_sk then do;      
            obsnum = _n_ + 1;
            set val_price_fact_future_compres(keep = valid_from_dt
                        rename = (valid_from_dt = etls_closedate))
                point = obsnum;
            valid_to_dt = etls_closedate - 1;            
         end;       
      run;

      %rcSet(&syserr); 
      
      /* delete indexes and constraints; they will be recreated after load */
      
      %di_util_truncate_table(trg_lib.price_fact_future);

      %etl_drop(trg_lib.price_fact_future,ic);
      %etl_drop(trg_lib.price_fact_future,index);  

      proc append base = trg_lib.PRICE_FACT_FUTURE
                  data = Val_price_fact_future_compres force;
      quit;

      %rcSet(&syserr); 
       
   %end;
   
%mend;

%etls_loader_ppf;

/*---- End of User Written Code  ----*/ 

/*---- Start of User Written Code  ----*/ 

/*============================================================================* 
 * Step:            UW - Post Process                       A5RCIHUB.BC0004KS * 
 * Transform:       Summary Statistics                                        * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:    PRICE_FACT_FUTURE -                     A5RCIHUB.BR0002MN * 
 *                   DI_DM.PRICE_FACT_FUTURE                                  * 
 *                                                                            * 
 * User Written:    Post Incremental                                          * 
 *============================================================================*/ 

%macro Post_incrProcess;
   /*recreate indexes and constraints on PRICE_FACT_FUTURE */
   %di_util_index_name(
       lib             = trg_lib, 
       table           = PRICE_FACT_FUTURE, 
       columns         = prod_hier_sk,
       create_idx_name = prod_hier_sk
    ); 

   %let etls_recordsAfter = %di_util_nobs(trg_lib.PRICE_FACT_FUTURE); 

%if %symexist(part_sk) %then %do;
   %let etls_lib=d_&part_sk;
   %put etls_lib=&etls_lib;
%end;
%else
   %let etls_lib=di_dm;

%mend Post_incrProcess;

%Post_incrProcess;
/*---- End of User Written Code  ----*/ 

/*---- Start of Post-Process Code  ----*/ 

PROC DATASETS LIBRARY = work kill nolist nowarn memtype=(data view);
QUIT; RUN;
/*---- End of Post-Process Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

%let etls_endTime = %sysfunc(datetime(),datetime.);

/*---- Job status macro  ----*/ 
%etls_sendJobStatus(source_table = stg_lib.&src_table,dataset=err_lib.job_status);

libname err_lib clear;
libname stg_lib clear;
libname trg_lib clear;
